# -*- encoding: utf-8 -*-
##############################################################################
#
#    Addition to OpenERP, Open Source Management Solution   
#    Copyright (C) 2004-2012 Vertel. All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields
from tools.translate import _

class account_invoice(osv.osv):
    _inherit = 'account.invoice'
    
    def action_move_create(self, cr, uid, ids, *args):    
        for inv in self.browse(cr, uid, ids):
            device_id = self.pool.get('account.invoice.line').mdm_device_create(cr, uid, inv.invoice_line)
        return super(account_invoice, self).action_move_create(cr, uid, ids, *args)

    def action_number(self, cr, uid, ids, *args):
        result = super(account_invoice, self).action_number(cr, uid, ids, *args)
        for inv in self.browse(cr, uid, ids):        
            for line in inv.invoice_line:
                if line.mdm_create == True:
                    self.pool.get('mdm.devices').log(cr, uid, line.device_id, _("Created new device from %s") % inv.number)
        return result

account_invoice()

class account_invoice_line(osv.osv):
    _inherit = 'account.invoice.line'
    _columns = {
        'device_id': fields.many2one('mdm.devices', 'Device Id'),
        'mdm_create': fields.boolean('New Mobile Device', help='Check this field if this line is a mobile device and you want to register it as a new device. Use Analytic Account for additional costs'),
    }
    def mdm_device_create(self, cr, uid, lines, context=None):
        context = context or {}
        for line in lines:
            if line.mdm_create == True:
                device_id = self.pool.get('mdm.devices').create(cr, uid, {
                        'description': line.name,
                        'code': line.invoice_id.number or False,
                        'pcost': line.price_subtotal,
                        'partner_id': line.invoice_id.partner_id.id,
                        'company_id': line.invoice_id.company_id.id,
                }, context=context)
                device = self.pool.get('mdm.devices').browse(cr, uid,device_id,context=context)
                self.pool.get('account.invoice.line').write(cr,uid,line.id,{
                    'device_id': device.id,
                    'account_analytic_id': device.analytic_account_id.id,
                    },context=context)
                self.log(cr, uid, line.id, _("Created new mobile device %s") % device.name)
                self.pool.get('mdm.devices').log(cr, uid, device.id, _("Created new device from %s") % line.invoice_id.number)
        return True
account_invoice_line()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
